﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace WindowsFormsApp1
{
    /// <summary>
    /// Построите график функции для своего варианта из практической
    /// работы № 4 Реализация циклических алгоритмов УП. 02.02. 
    /// </summary>
    public partial class Graph : Form
    {
        public Graph()
        {
            InitializeComponent();
        }
        /// <summary>
        /// Заполнение переменных
        /// </summary>
        /// <param name="x0"> Заполнение минимального значения </param>
        /// <param name="xk"> Заполнение максимального значения </param>
        /// <param name="dx"> Заполнение шага </param>
        public void CalculateNum(out double x0, out double xk, out double dx)
        {
            x0 = 0;
            xk = 0;
            dx = 0;
            try
            {
                x0 = Convert.ToDouble(tbInputX0.Text);
            }
            catch
            {
                tbInputX0.Text = "Ошибка";
            }
            try
            {
                xk = Convert.ToDouble(tbInputXk.Text);
            }
            catch
            {
                tbInputXk.Text = "Ошибка";
            }
            try
            {
                dx = Convert.ToDouble(tbInputDx.Text);
            }
            catch
            {
                tbInputDx.Text = "Ошибка";
            }
        }
        /// <summary>
        /// Метод высчитывает и строит график
        /// </summary>
        public void Resh()
        {
            CalculateNum(out double x0, out double xk, out double dx);
            //Количество точек в графе
            int count = Convert.ToInt32((int)Math.Ceiling((xk - x0) / dx) + 1); 
            //Массив значений X - общий для обоих графиков
            double[] x = new double[count];
            //Два массива Y - по одному для каждого графика
            double[] y1 = new double[count];
            double[] y2 = new double[count];
            //Расчитываем точки для графиков функции
            for (int i = 0; i < count; i++)
            {
                //Вычисляем значение X
                x[i] = x0 + xk * i;
                //Вычисляем значение функций в точке X
                y1[i] = Math.Round((Math.Pow(Math.Log(Math.Sin(Math.Pow(i, 3) + 0.0025)), 3 / 2)) + (0.8 * Math.Pow(10, -3)), 4);
                y2[i] = Math.Round((Math.Pow(Math.Log(Math.Cos(Math.Pow(i, 3) + 0.0025)), 3 / 2)) + (0.8 * Math.Pow(10, -3)), 4);
            }
            //Настраиваем оси графика 
            ctGraph.ChartAreas[0].AxisX.Minimum = x0;
            ctGraph.ChartAreas[0].AxisX.Maximum = xk;
            //Определяем шаг
            ctGraph.ChartAreas[0].AxisX.MajorGrid.Interval = dx;
            //Добовляем вычисленные значения в графики
            ctGraph.Series[0].Points.DataBindXY(x, y1);
            ctGraph.Series[1].Points.DataBindXY(x, y2);
        }
        /// <summary>
        /// Обработка нажатия 
        /// </summary>
        private void btnCalculate_Click(object sender, EventArgs e)
        {
            Resh();
        }
    }
}
